org.eclipse.wst.jsdt.core.ast

## Interface IASTNode

All Known Subinterfaces:
  IAbstractFunctionDeclaration, IAbstractVariableDeclaration, IAND_AND_Expression, IArgument, IArrayAllocationExpression, IArrayInitializer, IArrayQualifiedTypeReference, IArrayReference, IArrayTypeReference, IAssignment, IBinaryExpression, IBlock, IBranchStatement, IBreakStatement, ICaseStatement, ICombinedBinaryExpression, ICompoundAssignment, IConditionalExpression, IConstructorDeclaration, IContinueStatement, IDebuggerStatement, IDoStatement, IDoubleLiteral, IEmptyExpression, IEmptyStatement, IEqualExpression, IExplicitConstructorCall, IExpression, IExtendedStringLiteral, IFalseLiteral, IFieldDeclaration, IFieldReference, IForeachStatement, IForInStatement, IForStatement, IFunctionCall, IFunctionDeclaration, IFunctionExpression, IIfStatement, IImportReference, IInitializer, IInstanceOfExpression, IIntLiteral, IIntLiteralMinValue, IJsDoc, IJsDocArgumentExpression, IJsDocArrayQualifiedTypeReference, IJsDocArraySingleTypeReference, IJsDocFieldReference, IJsDocImplicitTypeReference, IJsDocMessageSend, IJsDocQualifiedTypeReference, IJsDocReturnStatement, IJsDocSingleNameReference, IJsDocSingleTypeReference, ILabeledStatement, IListExpression, ILiteral, ILocalDeclaration, IMagicLiteral, INameReference, INullLiteral, INumberLiteral, IObjectLiteral, IObjectLiteralField, IOperatorExpression, IOR_OR_Expression, IPostfixExpression, IPrefixExpression, IProgramElement, IQualifiedNameReference, IQualifiedThisReference, IQualifiedTypeReference, IReference, IRegExLiteral, IReturnStatement, IScriptFileDeclaration, ISingleNameReference, ISingleTypeReference, IStatement, IStringLiteral, IStringLiteralConcatenation, ISubRoutineStatement, ISuperReference, ISwitchStatement, IThisReference, IThrowStatement, ITrueLiteral, ITryStatement, ITypeDeclaration, ITypeReference, IUnaryExpression, IUndefinedLiteral, IWhileStatement, IWithStatement

All Known Implementing Classes:
  org.eclipse.wst.jsdt.internal.compiler.ast.ASTNode, InferredAttribute, InferredMember, InferredMethod, InferredType

    public interface IASTNode

Abstract base class for AST nodes.

This interface is not intended to be implemented by clients.

Provisional API: This class/interface is part of an interim API that is still under development and expected to change significantly before reaching stability. It is being made available at this early stage to solicit feedback from pioneering adopters on the understanding that any code that uses this API will almost certainly be broken (repeatedly) as the API evolves.

### Field Summary

Fields
`static int` `ABSTRACT_FUNCTION_DECLARATION`
`static int` `ABSTRACT_VARIABLE_DECLARATION`
`static int` `ALLOCATION_EXPRESSION`
`static int` `AND_AND_EXPRESSION`
`static int` `ARGUMENT`
`static int` `ARRAY_ALLOCATION_EXPRESSION`
`static int` `ARRAY_INITIALIZER`
`static int` `ARRAY_QUALIFIED_TYPE_REFERENCE`
`static int` `ARRAY_REFERENCE`
`static int` `ARRAY_TYPE_REFERENCE`
`static int` `ASSIGNMENT`
`static int` `AST_NODE`
`static int` `BINARY_EXPRESSION`
`static int` `BLOCK`
`static int` `BRANCH_STATEMENT`
`static int` `BREAK_STATEMENT`
`static int` `CASE_STATEMENT`
`static int` `CHAR_LITERAL`
`static int` `CL_INIT`
`static int` `CLASS_LITERAL_ACCESS`
`static int` `COMBINED_BINARY_EXPRESSION`
`static int` `COMPOUND_ASSIGNMENT`
`static int` `CONDITIONAL_EXPRESSION`
`static int` `CONSTRUCTOR_DECLARATION`
`static int` `CONTINUE_STATEMENT`
`static int` `DO_STATEMENT`
`static int` `DOUBLE_LITERAL`
`static int` `EMPTY_EXPRESSION`
`static int` `EMPTY_STATEMENT`
`static int` `EQUAL_EXPRESSION`
`static int` `EXPLICIT_CONSTRUCTOR_CALL`
`static int` `EXPRESSION`
`static int` `EXTENDED_STRING_LITERAL`
`static int` `FALSE_LITERAL`
`static int` `FIELD_DECLARATION`
`static int` `FIELD_REFERENCE`
`static int` `FLOAT_LITERAL`
`static int` `FOR_EACH_STATEMENT`
`static int` `FOR_IN_STATEMENT`
`static int` `FOR_STATEMENT`
`static int` `FUNCTION_CALL`
`static int` `FUNCTION_DECLARATION`
`static int` `FUNCTION_EXPRESSION`
`static int` `IF_STATEMENT`
`static int` `IMPORT_REFERENCE`
`static int` `INITIALIZER`
`static int` `INSTANCEOF_EXPRESSION`
`static int` `INT_LITERAL`
`static int` `INT_LITERAL_MIN_VALUE`
`static int` `JSDOC`
`static int` `JSDOC_ALLOCATION_EXPRESSION`
`static int` `JSDOC_ARGUMENTEXPRESSION`
`static int` `JSDOC_ARRAY_QUALIFIED_TYPE_REFERENCE`
`static int` `JSDOC_ARRAY_SINGLE_TYPE_REFERENCE`
`static int` `JSDOC_FIELD_REFERENCE`
`static int` `JSDOC_IMPLICIT_TYPE_REFERENCE`
`static int` `JSDOC_MESSAGE_SEND`
`static int` `JSDOC_QUALIFIED_TYPE_REFERENCE`
`static int` `JSDOC_RETURN_STATEMENT`
`static int` `JSDOC_SINGLE_NAME_REFERENCE`
`static int` `JSDOC_SINGLE_TYPE_REFERENCE`
`static int` `LABELED_STATEMENT`
`static int` `LIST_EXPRESSION`
`static int` `LITERAL`
`static int` `LOCAL_DECLARATION`
`static int` `LONG_LITERAL`
`static int` `LONG_LITERAL_MIN_VALUE`
`static int` `MAGIC_LITERAL`
`static int` `NAME_REFERENCE`
`static int` `NULL_LITERAL`
`static int` `NUMBER_LITERAL`
`static int` `OBJECT_GETTER_SETTER_FIELD`
`static int` `OBJECT_LITERAL`
`static int` `OBJECT_LITERAL_FIELD`
`static int` `OPERATOR_EXPRESSION`
`static int` `OR_OR_EXPRESSION`
`static int` `PARAMETERIZED_QUALIFIED_TYPE_REFERENCE`
`static int` `PARAMETERIZED_SINGLE_TYPE_REFERENCE`
`static int` `POSTFIX_EXPRESSION`
`static int` `PREFIX_EXPRESSION`
`static int` `PROGRAM_ELEMENT`
`static int` `QUALIFIED_ALLOCATION_EXPRESSION`
`static int` `QUALIFIED_NAME_REFERENCE`
`static int` `QUALIFIED_SUPER_REFERENCE`
`static int` `QUALIFIED_THIS_REFERENCE`
`static int` `QUALIFIED_TYPE_REFERENCE`
`static int` `REFERENCE`
`static int` `REG_EX_LITERAL`
`static int` `RETURN_STATEMENT`
`static int` `SCRIPT_FILE_DECLARATION`
`static int` `SINGLE_NAME_REFERENCE`
`static int` `SINGLE_TYPE_REFERENCE`
`static int` `STATEMENT`
`static int` `STRING_LITERAL`
`static int` `STRING_LITERAL_CONCATENATION`
`static int` `SUB_ROUTINE_STATEMENT`
`static int` `SUPER_REFERENCE`
`static int` `SWITCH_STATEMENT`
`static int` `THIS_REFERENCE`
`static int` `THROW_STATEMENT`
`static int` `TRUE_LITERAL`
`static int` `TRY_STATEMENT`
`static int` `TYPE_DECLARATION`
`static int` `TYPE_PARAMETER`
`static int` `TYPE_REFERENCE`
`static int` `UNARY_EXPRESSION`
`static int` `UNDEFINED_LITERAL`
`static int` `WHILE_STATEMENT`
`static int` `WITH_STATEMENT`

### Method Summary

All Methods Instance Methods Abstract Methods
`int` `getASTType()`
`int` `sourceEnd()`
`int` `sourceStart()`
`void` `traverse(ASTVisitor visitor)`

### Field Detail

#### AST_NODE

    static final int AST_NODE

See Also:
  Constant Field Values

#### ABSTRACT_FUNCTION_DECLARATION

    static final int ABSTRACT_FUNCTION_DECLARATION

See Also:
  Constant Field Values

#### ABSTRACT_VARIABLE_DECLARATION

    static final int ABSTRACT_VARIABLE_DECLARATION

See Also:
  Constant Field Values

#### ALLOCATION_EXPRESSION

    static final int ALLOCATION_EXPRESSION

See Also:
  Constant Field Values

#### AND_AND_EXPRESSION

    static final int AND_AND_EXPRESSION

See Also:
  Constant Field Values

#### ARGUMENT

    static final int ARGUMENT

See Also:
  Constant Field Values

#### ARRAY_ALLOCATION_EXPRESSION

    static final int ARRAY_ALLOCATION_EXPRESSION

See Also:
  Constant Field Values

#### ARRAY_INITIALIZER

    static final int ARRAY_INITIALIZER

See Also:
  Constant Field Values

#### ARRAY_QUALIFIED_TYPE_REFERENCE

    static final int ARRAY_QUALIFIED_TYPE_REFERENCE

See Also:
  Constant Field Values

#### ARRAY_REFERENCE

    static final int ARRAY_REFERENCE

See Also:
  Constant Field Values

#### ARRAY_TYPE_REFERENCE

    static final int ARRAY_TYPE_REFERENCE

See Also:
  Constant Field Values

#### ASSIGNMENT

    static final int ASSIGNMENT

See Also:
  Constant Field Values

#### BINARY_EXPRESSION

    static final int BINARY_EXPRESSION

See Also:
  Constant Field Values

#### BLOCK

    static final int BLOCK

See Also:
  Constant Field Values

#### BRANCH_STATEMENT

    static final int BRANCH_STATEMENT

See Also:
  Constant Field Values

#### BREAK_STATEMENT

    static final int BREAK_STATEMENT

See Also:
  Constant Field Values

#### CASE_STATEMENT

    static final int CASE_STATEMENT

See Also:
  Constant Field Values

#### CHAR_LITERAL

    static final int CHAR_LITERAL

See Also:
  Constant Field Values

#### COMBINED_BINARY_EXPRESSION

    static final int COMBINED_BINARY_EXPRESSION

See Also:
  Constant Field Values

#### COMPOUND_ASSIGNMENT

    static final int COMPOUND_ASSIGNMENT

See Also:
  Constant Field Values

#### CONDITIONAL_EXPRESSION

    static final int CONDITIONAL_EXPRESSION

See Also:
  Constant Field Values

#### CONSTRUCTOR_DECLARATION

    static final int CONSTRUCTOR_DECLARATION

See Also:
  Constant Field Values

#### CONTINUE_STATEMENT

    static final int CONTINUE_STATEMENT

See Also:
  Constant Field Values

#### DO_STATEMENT

    static final int DO_STATEMENT

See Also:
  Constant Field Values

#### DOUBLE_LITERAL

    static final int DOUBLE_LITERAL

See Also:
  Constant Field Values

#### EMPTY_EXPRESSION

    static final int EMPTY_EXPRESSION

See Also:
  Constant Field Values

#### EMPTY_STATEMENT

    static final int EMPTY_STATEMENT

See Also:
  Constant Field Values

#### EQUAL_EXPRESSION

    static final int EQUAL_EXPRESSION

See Also:
  Constant Field Values

#### EXPLICIT_CONSTRUCTOR_CALL

    static final int EXPLICIT_CONSTRUCTOR_CALL

See Also:
  Constant Field Values

#### EXPRESSION

    static final int EXPRESSION

See Also:
  Constant Field Values

#### EXTENDED_STRING_LITERAL

    static final int EXTENDED_STRING_LITERAL

See Also:
  Constant Field Values

#### FALSE_LITERAL

    static final int FALSE_LITERAL

See Also:
  Constant Field Values

#### FIELD_DECLARATION

    static final int FIELD_DECLARATION

See Also:
  Constant Field Values

#### FIELD_REFERENCE

    static final int FIELD_REFERENCE

See Also:
  Constant Field Values

#### FLOAT_LITERAL

    static final int FLOAT_LITERAL

See Also:
  Constant Field Values

#### FOR_EACH_STATEMENT

    static final int FOR_EACH_STATEMENT

See Also:
  Constant Field Values

#### FOR_IN_STATEMENT

    static final int FOR_IN_STATEMENT

See Also:
  Constant Field Values

#### FOR_STATEMENT

    static final int FOR_STATEMENT

See Also:
  Constant Field Values

#### FUNCTION_CALL

    static final int FUNCTION_CALL

See Also:
  Constant Field Values

#### FUNCTION_DECLARATION

    static final int FUNCTION_DECLARATION

See Also:
  Constant Field Values

#### FUNCTION_EXPRESSION

    static final int FUNCTION_EXPRESSION

See Also:
  Constant Field Values

#### IF_STATEMENT

    static final int IF_STATEMENT

See Also:
  Constant Field Values

#### IMPORT_REFERENCE

    static final int IMPORT_REFERENCE

See Also:
  Constant Field Values

#### INITIALIZER

    static final int INITIALIZER

See Also:
  Constant Field Values

#### INSTANCEOF_EXPRESSION

    static final int INSTANCEOF_EXPRESSION

See Also:
  Constant Field Values

#### INT_LITERAL

    static final int INT_LITERAL

See Also:
  Constant Field Values

#### INT_LITERAL_MIN_VALUE

    static final int INT_LITERAL_MIN_VALUE

See Also:
  Constant Field Values

#### JSDOC

    static final int JSDOC

See Also:
  Constant Field Values

#### JSDOC_ALLOCATION_EXPRESSION

    static final int JSDOC_ALLOCATION_EXPRESSION

See Also:
  Constant Field Values

#### JSDOC_ARGUMENTEXPRESSION

    static final int JSDOC_ARGUMENTEXPRESSION

See Also:
  Constant Field Values

#### JSDOC_ARRAY_QUALIFIED_TYPE_REFERENCE

    static final int JSDOC_ARRAY_QUALIFIED_TYPE_REFERENCE

See Also:
  Constant Field Values

#### JSDOC_ARRAY_SINGLE_TYPE_REFERENCE

    static final int JSDOC_ARRAY_SINGLE_TYPE_REFERENCE

See Also:
  Constant Field Values

#### JSDOC_FIELD_REFERENCE

    static final int JSDOC_FIELD_REFERENCE

See Also:
  Constant Field Values

#### JSDOC_IMPLICIT_TYPE_REFERENCE

    static final int JSDOC_IMPLICIT_TYPE_REFERENCE

See Also:
  Constant Field Values

#### JSDOC_MESSAGE_SEND

    static final int JSDOC_MESSAGE_SEND

See Also:
  Constant Field Values

#### JSDOC_QUALIFIED_TYPE_REFERENCE

    static final int JSDOC_QUALIFIED_TYPE_REFERENCE

See Also:
  Constant Field Values

#### JSDOC_RETURN_STATEMENT

    static final int JSDOC_RETURN_STATEMENT

See Also:
  Constant Field Values

#### JSDOC_SINGLE_NAME_REFERENCE

    static final int JSDOC_SINGLE_NAME_REFERENCE

See Also:
  Constant Field Values

#### JSDOC_SINGLE_TYPE_REFERENCE

    static final int JSDOC_SINGLE_TYPE_REFERENCE

See Also:
  Constant Field Values

#### LABELED_STATEMENT

    static final int LABELED_STATEMENT

See Also:
  Constant Field Values

#### LIST_EXPRESSION

    static final int LIST_EXPRESSION

See Also:
  Constant Field Values

#### LITERAL

    static final int LITERAL

See Also:
  Constant Field Values

#### LOCAL_DECLARATION

    static final int LOCAL_DECLARATION

See Also:
  Constant Field Values

#### LONG_LITERAL

    static final int LONG_LITERAL

See Also:
  Constant Field Values

#### LONG_LITERAL_MIN_VALUE

    static final int LONG_LITERAL_MIN_VALUE

See Also:
  Constant Field Values

#### MAGIC_LITERAL

    static final int MAGIC_LITERAL

See Also:
  Constant Field Values

#### NAME_REFERENCE

    static final int NAME_REFERENCE

See Also:
  Constant Field Values

#### NULL_LITERAL

    static final int NULL_LITERAL

See Also:
  Constant Field Values

#### NUMBER_LITERAL

    static final int NUMBER_LITERAL

See Also:
  Constant Field Values

#### OBJECT_LITERAL

    static final int OBJECT_LITERAL

See Also:
  Constant Field Values

#### OBJECT_LITERAL_FIELD

    static final int OBJECT_LITERAL_FIELD

See Also:
  Constant Field Values

#### OPERATOR_EXPRESSION

    static final int OPERATOR_EXPRESSION

See Also:
  Constant Field Values

#### OR_OR_EXPRESSION

    static final int OR_OR_EXPRESSION

See Also:
  Constant Field Values

#### PARAMETERIZED_QUALIFIED_TYPE_REFERENCE

    static final int PARAMETERIZED_QUALIFIED_TYPE_REFERENCE

See Also:
  Constant Field Values

#### PARAMETERIZED_SINGLE_TYPE_REFERENCE

    static final int PARAMETERIZED_SINGLE_TYPE_REFERENCE

See Also:
  Constant Field Values

#### POSTFIX_EXPRESSION

    static final int POSTFIX_EXPRESSION

See Also:
  Constant Field Values

#### PREFIX_EXPRESSION

    static final int PREFIX_EXPRESSION

See Also:
  Constant Field Values

#### PROGRAM_ELEMENT

    static final int PROGRAM_ELEMENT

See Also:
  Constant Field Values

#### QUALIFIED_ALLOCATION_EXPRESSION

    static final int QUALIFIED_ALLOCATION_EXPRESSION

See Also:
  Constant Field Values

#### QUALIFIED_NAME_REFERENCE

    static final int QUALIFIED_NAME_REFERENCE

See Also:
  Constant Field Values

#### QUALIFIED_SUPER_REFERENCE

    static final int QUALIFIED_SUPER_REFERENCE

See Also:
  Constant Field Values

#### QUALIFIED_THIS_REFERENCE

    static final int QUALIFIED_THIS_REFERENCE

See Also:
  Constant Field Values

#### QUALIFIED_TYPE_REFERENCE

    static final int QUALIFIED_TYPE_REFERENCE

See Also:
  Constant Field Values

#### REFERENCE

    static final int REFERENCE

See Also:
  Constant Field Values

#### REG_EX_LITERAL

    static final int REG_EX_LITERAL

See Also:
  Constant Field Values

#### RETURN_STATEMENT

    static final int RETURN_STATEMENT

See Also:
  Constant Field Values

#### SCRIPT_FILE_DECLARATION

    static final int SCRIPT_FILE_DECLARATION

See Also:
  Constant Field Values

#### SINGLE_NAME_REFERENCE

    static final int SINGLE_NAME_REFERENCE

See Also:
  Constant Field Values

#### SINGLE_TYPE_REFERENCE

    static final int SINGLE_TYPE_REFERENCE

See Also:
  Constant Field Values

#### STATEMENT

    static final int STATEMENT

See Also:
  Constant Field Values

#### STRING_LITERAL

    static final int STRING_LITERAL

See Also:
  Constant Field Values

#### STRING_LITERAL_CONCATENATION

    static final int STRING_LITERAL_CONCATENATION

See Also:
  Constant Field Values

#### SUB_ROUTINE_STATEMENT

    static final int SUB_ROUTINE_STATEMENT

See Also:
  Constant Field Values

#### SUPER_REFERENCE

    static final int SUPER_REFERENCE

See Also:
  Constant Field Values

#### SWITCH_STATEMENT

    static final int SWITCH_STATEMENT

See Also:
  Constant Field Values

#### THIS_REFERENCE

    static final int THIS_REFERENCE

See Also:
  Constant Field Values

#### THROW_STATEMENT

    static final int THROW_STATEMENT

See Also:
  Constant Field Values

#### TRUE_LITERAL

    static final int TRUE_LITERAL

See Also:
  Constant Field Values

#### TRY_STATEMENT

    static final int TRY_STATEMENT

See Also:
  Constant Field Values

#### TYPE_DECLARATION

    static final int TYPE_DECLARATION

See Also:
  Constant Field Values

#### TYPE_PARAMETER

    static final int TYPE_PARAMETER

See Also:
  Constant Field Values

#### TYPE_REFERENCE

    static final int TYPE_REFERENCE

See Also:
  Constant Field Values

#### UNARY_EXPRESSION

    static final int UNARY_EXPRESSION

See Also:
  Constant Field Values

#### UNDEFINED_LITERAL

    static final int UNDEFINED_LITERAL

See Also:
  Constant Field Values

#### WHILE_STATEMENT

    static final int WHILE_STATEMENT

See Also:
  Constant Field Values

#### WITH_STATEMENT

    static final int WITH_STATEMENT

See Also:
  Constant Field Values

#### CLASS_LITERAL_ACCESS

    static final int CLASS_LITERAL_ACCESS

See Also:
  Constant Field Values

#### CL_INIT

    static final int CL_INIT

See Also:
  Constant Field Values

#### OBJECT_GETTER_SETTER_FIELD

    static final int OBJECT_GETTER_SETTER_FIELD

See Also:
  Constant Field Values

### Method Detail

#### sourceStart

    int sourceStart()

#### sourceEnd

    int sourceEnd()

#### getASTType

    int getASTType()

#### traverse

    void traverse(ASTVisitor visitor)